'use strict';

const index = require('./index-05554ce6.js');
const uiStore = require('./ui-store-7807fa2a.js');

function SyncWithStore() {
    return function (proto, propName) {
        const { connectedCallback, disconnectedCallback } = proto;
        proto.connectedCallback = function () {
            const host = index.getElement(this);
            const value = host[propName];
            if (!value) {
                const storeValue = uiStore.uiStore.state[propName];
                host[propName] = storeValue;
                uiStore.appendElement(propName, host);
            }
            return connectedCallback === null || connectedCallback === void 0 ? void 0 : connectedCallback.call(this);
        };
        proto.disconnectedCallback = function () {
            uiStore.removeElement(propName, index.getElement(this));
            return disconnectedCallback === null || disconnectedCallback === void 0 ? void 0 : disconnectedCallback.call(this);
        };
    };
}

exports.SyncWithStore = SyncWithStore;
