'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index$1 = require('./index-05554ce6.js');
const uiStore = require('./ui-store-7807fa2a.js');
const sidebar = require('./sidebar-8256d60e.js');
const index = require('./index-49c92728.js');

const rtkChatToggleCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}:host{position:relative;display:block}:host([data-hidden]){display:none}.unread-count{position:absolute;right:var(--rtk-space-3, 12px);box-sizing:border-box;padding:var(--rtk-space-0\\.5, 2px);-webkit-user-select:none;-moz-user-select:none;user-select:none;--tw-bg-opacity:1;background-color:rgba(var(--rtk-colors-brand-500, 33 96 253) / var(--tw-bg-opacity));font-size:12px;color:rgb(var(--rtk-colors-text-on-brand-1000, var(--rtk-colors-text-1000, 255 255 255)));display:flex;height:var(--rtk-space-5, 20px);min-width:var(--rtk-space-5, 20px);align-items:center;justify-content:center;border-radius:9999px;z-index:1}.unread-count-dot{position:absolute;right:var(--rtk-space-3, 12px);z-index:10;--tw-bg-opacity:1;background-color:rgba(var(--rtk-colors-brand-500, 33 96 253) / var(--tw-bg-opacity));border-radius:50%;display:flex;height:var(--rtk-space-4, 16px);width:var(--rtk-space-4, 16px);align-items:center;justify-content:center}:host([variant='horizontal']) .unread-count{right:var(--rtk-space-4, 16px);top:50%;--tw-translate-y:-50%;transform:translate(var(--tw-translate-x), var(--tw-translate-y)) rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}";
const RtkChatToggleStyle0 = rtkChatToggleCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkChatToggle = class {
    constructor(hostRef) {
        index$1.registerInstance(this, hostRef);
        this.stateUpdate = index$1.createEvent(this, "rtkStateUpdate", 7);
        this.unreadMessageCount = 0;
        /** Variant */
        this.variant = 'button';
        /** Icon pack */
        this.iconPack = uiStore.defaultIconPack;
        /** Language */
        this.t = uiStore.useLanguage();
        this.chatActive = false;
        this.canViewChat = false;
        /**
         * Only used when paginated chat is enabled
         */
        this.hasNewMessages = false;
        this.onChatUpdate = ({ action, message }) => {
            var _a;
            if (this.chatActive)
                return;
            if (action === 'add' && message.userId !== ((_a = this.meeting) === null || _a === void 0 ? void 0 : _a.self.userId)) {
                this.hasNewMessages = true;
                this.unreadMessageCount += 1;
            }
        };
        this.toggleChat = () => {
            const states = this.states;
            this.chatActive = !((states === null || states === void 0 ? void 0 : states.activeSidebar) && (states === null || states === void 0 ? void 0 : states.sidebar) === 'chat');
            if (this.chatActive) {
                this.unreadMessageCount = 0;
                this.hasNewMessages = false;
            }
            this.stateUpdate.emit({
                activeSidebar: this.chatActive,
                sidebar: this.chatActive ? 'chat' : undefined,
                activeMoreMenu: false,
                activeAI: false,
            });
        };
        this.updateCanView = () => {
            this.canViewChat = sidebar.canViewChat(this.meeting);
        };
    }
    connectedCallback() {
        this.meetingChanged(this.meeting);
        this.statesChanged(this.states);
    }
    disconnectedCallback() {
        var _a, _b, _c, _d, _e, _f;
        (_b = (_a = this.meeting) === null || _a === void 0 ? void 0 : _a.chat) === null || _b === void 0 ? void 0 : _b.removeListener('chatUpdate', this.onChatUpdate);
        (_d = (_c = this.meeting) === null || _c === void 0 ? void 0 : _c.stage) === null || _d === void 0 ? void 0 : _d.removeListener('stageStatusUpdate', this.updateCanView);
        (_f = (_e = this.meeting) === null || _e === void 0 ? void 0 : _e.self) === null || _f === void 0 ? void 0 : _f.permissions.removeListener('chatUpdate', this.updateCanView);
    }
    meetingChanged(meeting) {
        var _a, _b, _c, _d, _e, _f, _g;
        if (meeting == null)
            return;
        if (uiStore.usePaginatedChat(meeting)) {
            (_a = meeting.chat) === null || _a === void 0 ? void 0 : _a.getMessages(new Date().getTime(), 1, true).then((res) => {
                var _a;
                if ((_a = res === null || res === void 0 ? void 0 : res.messages) === null || _a === void 0 ? void 0 : _a.length)
                    this.hasNewMessages = true;
            });
        }
        const meetingStartedTimeMs = (_c = (_b = meeting.meta) === null || _b === void 0 ? void 0 : _b.meetingStartedTimestamp.getTime()) !== null && _c !== void 0 ? _c : 0;
        const newMessages = (_d = meeting.chat) === null || _d === void 0 ? void 0 : _d.messages.filter((m) => m.timeMs > meetingStartedTimeMs);
        this.unreadMessageCount = newMessages.length || 0;
        (_e = meeting.chat) === null || _e === void 0 ? void 0 : _e.addListener('chatUpdate', this.onChatUpdate);
        this.canViewChat = sidebar.canViewChat(meeting);
        (_f = meeting === null || meeting === void 0 ? void 0 : meeting.stage) === null || _f === void 0 ? void 0 : _f.on('stageStatusUpdate', this.updateCanView);
        (_g = meeting === null || meeting === void 0 ? void 0 : meeting.self) === null || _g === void 0 ? void 0 : _g.permissions.on('chatUpdate', this.updateCanView);
    }
    statesChanged(states) {
        if (states != null) {
            this.chatActive = states.activeSidebar === true && states.sidebar === 'chat';
        }
    }
    handleChatActiveChange() {
        // Chat sidebar closed without opening a different sidebar
        if (!this.chatActive && !this.states.activeSidebar) {
            this.buttonEl.focus();
        }
    }
    render() {
        if (!this.canViewChat)
            return index$1.h(index$1.Host, { "data-hidden": true });
        return (index$1.h(index$1.Host, { title: this.t('chat') }, uiStore.usePaginatedChat(this.meeting)
            ? this.hasNewMessages && index$1.h("div", { class: "unread-count-dot", part: "unread-count-dot" })
            : this.unreadMessageCount !== 0 &&
                !this.chatActive && (index$1.h("div", { class: "unread-count", part: "unread-count" }, index$1.h("span", null, this.unreadMessageCount <= 100 ? this.unreadMessageCount : '99+'))), index$1.h("rtk-controlbar-button", { ref: (el) => (this.buttonEl = el), part: "controlbar-button", size: this.size, iconPack: this.iconPack, class: { active: this.chatActive }, onClick: this.toggleChat, icon: this.iconPack.chat, label: this.t('chat'), variant: this.variant })));
    }
    static get watchers() { return {
        "meeting": ["meetingChanged"],
        "states": ["statesChanged"],
        "chatActive": ["handleChatActiveChange"]
    }; }
};
__decorate([
    index.SyncWithStore()
], RtkChatToggle.prototype, "meeting", void 0);
__decorate([
    index.SyncWithStore()
], RtkChatToggle.prototype, "states", void 0);
__decorate([
    index.SyncWithStore()
], RtkChatToggle.prototype, "size", void 0);
__decorate([
    index.SyncWithStore()
], RtkChatToggle.prototype, "iconPack", void 0);
__decorate([
    index.SyncWithStore()
], RtkChatToggle.prototype, "t", void 0);
RtkChatToggle.style = RtkChatToggleStyle0;

exports.rtk_chat_toggle = RtkChatToggle;
