'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index$1 = require('./index-05554ce6.js');
const index = require('./index-49c92728.js');
const uiStore = require('./ui-store-7807fa2a.js');

const rtkSidebarUiCss = ":host {\n  line-height: initial;\n  font-family: var(--rtk-font-family, sans-serif);\n\n  font-feature-settings: normal;\n  font-variation-settings: normal;\n}\n\np {\n  margin: var(--rtk-space-0, 0px);\n  padding: var(--rtk-space-0, 0px);\n}\n\n\n:host {\n  position: relative;\n  height: 100%;\n  width: 100%;\n  font-family: var(--rtk-font-family, sans-serif);\n  z-index: 50;\n  display: flex;\n  flex-direction: column;\n\n  container-type: size;\n  container-name: sidebarui;\n}\n\n@container sidebarui (height < 370px) {\n  .main-header {\n    height: var(--rtk-space-8, 32px) !important;\n  }\n  .close {\n    top: var(--rtk-space-0\\.5, 2px) !important;\n    left: var(--rtk-space-0, 0px) !important;\n    color: rgba(var(--rtk-colors-danger, 255 45 45) / 0.6);\n  }\n}\n\n:host([view='sidebar']) {\n  --tw-bg-opacity: 1;\n  background-color: rgba(var(--rtk-colors-background-900, 26 26 26) / var(--tw-bg-opacity));\n}\n\n:host([view='full-screen']) {\n  position: absolute;\n  top: var(--rtk-space-0, 0px);\n  right: var(--rtk-space-0, 0px);\n  bottom: var(--rtk-space-0, 0px);\n  left: var(--rtk-space-0, 0px);\n  max-width: 100%;\n  border: none;\n}\n\n::slotted(*) {\n  flex-grow: 1;\n}\n\n.close {\n  position: absolute;\n  top: var(--rtk-space-2, 8px);\n  left: var(--rtk-space-2, 8px);\n  z-index: 10;\n}\n\n.main-header {\n  position: relative;\n  display: flex;\n  height: var(--rtk-space-12, 48px);\n  place-items: center;\n  justify-content: center;\n}\n\n.main-header, \n.mobile-tabs {\n  flex-shrink: 0;\n}\n\n.mobile-tabs {\n  display: flex;\n  place-items: center;\n  justify-content: space-evenly;\n  border-bottom: 1px solid rgb(var(--rtk-colors-background-700, 44 44 44));\n}\n\n.mobile-tabs button {\n  margin: var(--rtk-space-0, 0px);\n  border-width: var(--rtk-border-width-none, 0);\n  border-style: none;\n  background-color: transparent;\n  padding: var(--rtk-space-0, 0px);\n  color: rgb(var(--rtk-colors-text-600, 255 255 255 / 0.52));\n  height: var(--rtk-space-10, 40px);\n  cursor: pointer;\n  padding-left: var(--rtk-space-4, 16px);\n  padding-right: var(--rtk-space-4, 16px);\n  font-weight: 500;\n  border-bottom: 1px solid transparent;\n}\n\n.mobile-tabs button.active {\n  --tw-border-opacity: 1;\n  border-color: rgba(var(--rtk-colors-brand-300, 73 124 253) / var(--tw-border-opacity));\n  --tw-text-opacity: 1;\n  color: rgba(var(--rtk-colors-brand-300, 73 124 253) / var(--tw-text-opacity));\n}\n\nheader h3 {\n  font-size: 14px;\n  font-weight: 500;\n}\n\n@media only screen and (max-device-height: 480px) and (orientation: landscape) {\n  .main-header {\n    display: none !important;\n  }\n}\n\n.tab-participant-count-badge {\n  display: inline-block;\n  padding: 2px 5px;\n  border-radius: 9999px;\n  --tw-bg-opacity: 1;\n  background-color: rgba(var(--rtk-colors-brand-500, 33 96 253) / var(--tw-bg-opacity));\n  font-size: 12px;\n  color: rgb(var(--rtk-colors-text-700, 255 255 255 / 0.64));\n}\n\n.tab-participant-count-badge:not(.selected-tab) {\n  --tw-bg-opacity: 1;\n  background-color: rgba(var(--rtk-colors-background-600, 60 60 60) / var(--tw-bg-opacity));\n}\n\n.tab-participant-count-badge.requests-pending{\n  background-color: rgba(var(--rtk-colors-danger));\n}\n";
const RtkSidebarUiStyle0 = rtkSidebarUiCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkSidebarUi = class {
    constructor(hostRef) {
        index$1.registerInstance(this, hostRef);
        this.tabChange = index$1.createEvent(this, "tabChange", 7);
        this.sidebarClose = index$1.createEvent(this, "sidebarClose", 7);
        /** View */
        this.view = 'sidebar';
        /** Tabs */
        this.tabs = [];
        /** Hide Main Header */
        this.hideHeader = false;
        /** Hide Close Action */
        this.hideCloseAction = false;
        /** Icon Pack */
        this.iconPack = uiStore.defaultIconPack;
        /** Option to focus close button when opened */
        this.focusCloseButton = true;
        /** Language */
        this.t = uiStore.useLanguage();
        this.onClose = () => {
            this.sidebarClose.emit();
        };
    }
    componentDidLoad() {
        this.keydownListener = (e) => {
            if (e.key === 'Escape') {
                this.onClose();
            }
        };
        this.hostEl.addEventListener('keydown', this.keydownListener);
        this.handleFocusCloseButton();
    }
    handleFocusCloseButton() {
        if (this.currentTab !== 'chat' && !this.hideCloseAction) {
            this.closeButton.focus();
        }
    }
    disconnectedCallback() {
        this.hostEl.removeEventListener('keydown', this.keydownListener);
    }
    render() {
        const isFullScreen = this.view === 'full-screen';
        const activeTab = this.tabs.find((tab) => tab.id === this.currentTab);
        return (index$1.h(index$1.Host, { key: '4afc881e8aeb5f51014817e1287aed7700bb56fb', ref: (el) => (this.hostEl = el), class: this.view }, !this.hideCloseAction && (index$1.h("rtk-button", { key: 'e95b2c25d32535630e0ccf30b46f067395c41a7f', ref: (el) => (this.closeButton = el), variant: "ghost", kind: "icon", class: "close", onClick: this.onClose, "aria-label": this.t('close') }, index$1.h("rtk-icon", { key: '0d6398171fbebd8d9b0895fc2e9f0b08e7980ab2', icon: this.iconPack.dismiss }))), activeTab && !this.hideHeader && (index$1.h("header", { key: 'e92a6c60fa280a36b4643873d48adca3210e3c51', class: "main-header" }, index$1.h("h3", { key: '8097b3e815c3005c7750c7076eb54242406034a9' }, activeTab.name), index$1.h("slot", { key: 'f91814a6fb62726790ae5c91111be0f6d1ea121c', name: "pinned-state" }))), isFullScreen && (index$1.h("header", { key: '5ec434bbc22ffa7acf8a76361e02718080c7a99d', class: "mobile-tabs" }, this.tabs.map((tab) => (index$1.h("button", { onClick: () => {
                this.tabChange.emit(tab.id);
            }, class: {
                active: this.currentTab === tab.id,
            } }, tab.name))))), index$1.h("slot", { key: '77ee9da399e6991cc7bf3e0d979ffeec47e4b769', name: this.currentTab })));
    }
    static get watchers() { return {
        "currentTab": ["handleFocusCloseButton"]
    }; }
};
__decorate([
    index.SyncWithStore()
], RtkSidebarUi.prototype, "t", void 0);
RtkSidebarUi.style = RtkSidebarUiStyle0;

exports.rtk_sidebar_ui = RtkSidebarUi;
