import { getElement } from "@stencil/core";
import { uiStore as store, appendElement, removeElement } from "./ui-store";
export function SyncWithStore() {
    return function (proto, propName) {
        const { connectedCallback, disconnectedCallback } = proto;
        proto.connectedCallback = function () {
            const host = getElement(this);
            const value = host[propName];
            if (!value) {
                const storeValue = store.state[propName];
                host[propName] = storeValue;
                appendElement(propName, host);
            }
            return connectedCallback === null || connectedCallback === void 0 ? void 0 : connectedCallback.call(this);
        };
        proto.disconnectedCallback = function () {
            removeElement(propName, getElement(this));
            return disconnectedCallback === null || disconnectedCallback === void 0 ? void 0 : disconnectedCallback.call(this);
        };
    };
}
