import { i as getElement } from './p-c3592601.js';
import { f as appendElement, r as removeElement, u as uiStore } from './p-fc4484ae.js';

function SyncWithStore() {
    return function (proto, propName) {
        const { connectedCallback, disconnectedCallback } = proto;
        proto.connectedCallback = function () {
            const host = getElement(this);
            const value = host[propName];
            if (!value) {
                const storeValue = uiStore.state[propName];
                host[propName] = storeValue;
                appendElement(propName, host);
            }
            return connectedCallback === null || connectedCallback === void 0 ? void 0 : connectedCallback.call(this);
        };
        proto.disconnectedCallback = function () {
            removeElement(propName, getElement(this));
            return disconnectedCallback === null || disconnectedCallback === void 0 ? void 0 : disconnectedCallback.call(this);
        };
    };
}

export { SyncWithStore as S };
