import { p as proxyCustomElement, H, h, e as Host } from './p-c3592601.js';
import { C as ChatHead } from './p-febe3ebc.js';
import { a as sanitizeLink } from './p-338c7261.js';
import { a as defaultIconPack, c as useLanguage } from './p-fc4484ae.js';
import { g as getExtension, a as getFileSize, d as downloadFile } from './p-9fc565cf.js';
import { S as SyncWithStore } from './p-989a34c9.js';
import { d as defineCustomElement$2 } from './p-2507c6c8.js';
import { d as defineCustomElement$1 } from './p-a73161da.js';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkFileMessage = /*@__PURE__*/ proxyCustomElement(class RtkFileMessage extends H {
    constructor() {
        super();
        this.__registerHost();
        /** Date object of now, to calculate distance between dates */
        this.now = new Date();
        /** Whether the message is continued by same user */
        this.isContinued = false;
        /** Icon pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
        /** show message in bubble */
        this.showBubble = false;
    }
    render() {
        const link = sanitizeLink(this.message.link);
        return (h(Host, { key: '25ff2cd29b951ffee9fb266ec4937258db527ef4' }, !this.isContinued && (h(ChatHead, { key: '50dc45f56ac2837215619c597f557c0e71e5fd85', name: this.message.displayName, time: this.message.time, now: this.now })), h("div", { key: '5b300ea679f835b6d7421568dde80aa38cbbc821', class: {
                body: true,
                bubble: this.showBubble,
            }, part: "body" }, h("div", { key: '895f033df99c8d9dfc1241bbaf5f20137b905395', class: "file" }, h("div", { key: '345bd0370a81c50c1ef46fa7119fa321213ad741', class: "file-data" }, h("div", { key: 'fb30c6c130af584d2f4294029c4304e213ddd339', class: "name" }, this.message.name), h("div", { key: 'd0de234e1697b196fe248bbfbad18109b59c20df', class: "file-data-split" }, h("div", { key: '635343bd7dbcbfeea1a7534c943be355decf20c4', class: "ext" }, getExtension(this.message.name)), h("span", { key: 'bd7772e273ae55297c99d8564cfa44e6dd1b43d0', class: "divider" }), h("div", { key: 'd6df3a4fca8932d3bcdeb805ef7b3bed1c3e8c15', class: "size" }, getFileSize(this.message.size)))), h("rtk-button", { key: '4b4d9be6f228e5deda5590f2aa6038b3501623d7', variant: "secondary", kind: "icon", onClick: () => downloadFile(link, { name: this.message.name, fallbackName: 'file' }), part: "button" }, h("rtk-icon", { key: '187e0b8f903bd7cd8b5f9e25ef2d6841299fe87f', icon: this.iconPack.download }))))));
    }
}, [0, "rtk-file-message", {
        "message": [16],
        "now": [16],
        "isContinued": [516, "is-continued"],
        "iconPack": [16],
        "t": [16],
        "showBubble": [4, "show-bubble"]
    }]);
__decorate([
    SyncWithStore()
], RtkFileMessage.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkFileMessage.prototype, "t", void 0);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["rtk-file-message", "rtk-button", "rtk-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "rtk-file-message":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, RtkFileMessage);
            }
            break;
        case "rtk-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "rtk-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { RtkFileMessage as R, defineCustomElement as d };
