import { p as proxyCustomElement, H, d as createEvent, h, e as Host } from './p-c3592601.js';
import { C as ChatHead } from './p-febe3ebc.js';
import { a as sanitizeLink } from './p-338c7261.js';
import { a as defaultIconPack, c as useLanguage } from './p-fc4484ae.js';
import { d as downloadFile } from './p-9fc565cf.js';
import { S as SyncWithStore } from './p-989a34c9.js';
import { d as defineCustomElement$3 } from './p-2507c6c8.js';
import { d as defineCustomElement$2 } from './p-a73161da.js';
import { d as defineCustomElement$1 } from './p-23d64784.js';

const rtkImageMessageCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}.image-spinner{cursor:wait}.image-errored{cursor:not-allowed}";
const RtkImageMessageStyle0 = rtkImageMessageCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkImageMessage = /*@__PURE__*/ proxyCustomElement(class RtkImageMessage extends H {
    constructor() {
        super();
        this.__registerHost();
        this.stateUpdate = createEvent(this, "rtkStateUpdate", 7);
        /** Date object of now, to calculate distance between dates */
        this.now = new Date();
        /** Whether the message is continued by same user */
        this.isContinued = false;
        /** Icon pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
        /** show message in bubble */
        this.showBubble = false;
        this.status = 'loading';
    }
    render() {
        return (h(Host, { key: '60b7d1f3569a3bd335b7db047ef5f5a7b8fa518c' }, !this.isContinued && (h(ChatHead, { key: 'e897d7239be3ba0a2594f5c6285cc5a5fd553375', name: this.message.displayName, time: this.message.time, now: this.now })), h("div", { key: 'f99332c642a51af6d4ab20eff1654826479b420b', class: {
                body: true,
                bubble: this.showBubble,
            }, part: "body" }, h("div", { key: '667e081aff8edd5792cc2b0fac09d83d6520d6a7', class: { image: true, loaded: this.status === 'loaded' } }, h("img", { key: 'f079a0f75038bdf6a83e450bfdb68ab84d6f1663', src: sanitizeLink(this.message.link), onLoad: () => {
                this.status = 'loaded';
            }, onError: () => {
                this.status = 'errored';
            }, onClick: () => {
                if (this.status === 'loaded') {
                    this.stateUpdate.emit({ image: this.message });
                }
            } }), this.status === 'loading' && (h("div", { key: '00968152adade14971180db8df90553a17aaaaa8', class: "image-spinner", title: this.t('chat.img.loading'), "aria-label": this.t('chat.img.loading') }, h("rtk-spinner", { key: '0e236fd24f70e5dfbd5528d1198c9ecf7f2f4888', iconPack: this.iconPack }))), this.status === 'errored' && (h("div", { key: '8cd94804cb58c23c9c4636e7d8e14e3121b3e169', class: "image-errored", title: this.t('chat.error.img_not_found'), "aria-label": this.t('chat.error.img_not_found') }, h("rtk-icon", { key: '625d50f65dfbd6af0f2061d96b5332452b060a12', icon: this.iconPack.image_off }))), this.status === 'loaded' && (h("div", { key: '4a5105c9deef32a5526d5adf8f6075230a09a90f', class: "actions" }, h("rtk-button", { key: 'f8519c23a87d30909451ceaf9c874b6b5258f4cb', class: "action", variant: "secondary", kind: "icon", onClick: () => {
                this.stateUpdate.emit({ image: this.message });
            } }, h("rtk-icon", { key: '3b8e52922b59e9f75f8a25bc9605f4d044b7981c', icon: this.iconPack.full_screen_maximize })), h("rtk-button", { key: 'dc2703a02f091383498eaddfdcdf148e93471a88', class: "action", variant: "secondary", kind: "icon", onClick: () => downloadFile(this.message.link, { fallbackName: 'image' }) }, h("rtk-icon", { key: '1d9c9406e7937c64c93d77d685e86c3d1def4ec1', icon: this.iconPack.download }))))))));
    }
    static get style() { return RtkImageMessageStyle0; }
}, [0, "rtk-image-message", {
        "message": [16],
        "now": [16],
        "isContinued": [516, "is-continued"],
        "iconPack": [16],
        "t": [16],
        "showBubble": [4, "show-bubble"],
        "status": [32]
    }]);
__decorate([
    SyncWithStore()
], RtkImageMessage.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkImageMessage.prototype, "t", void 0);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["rtk-image-message", "rtk-button", "rtk-icon", "rtk-spinner"];
    components.forEach(tagName => { switch (tagName) {
        case "rtk-image-message":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, RtkImageMessage);
            }
            break;
        case "rtk-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "rtk-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "rtk-spinner":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { RtkImageMessage as R, defineCustomElement as d };
