import { p as proxyCustomElement, H, h, e as Host } from './p-c3592601.js';
import { a as defaultIconPack, c as useLanguage } from './p-fc4484ae.js';
import { h as hasOnlyEmojis } from './p-338c7261.js';
import { C as ChatHead } from './p-febe3ebc.js';
import { S as SyncWithStore } from './p-989a34c9.js';
import { T as TextMessageView } from './p-a2f4f9e3.js';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkTextMessage = /*@__PURE__*/ proxyCustomElement(class RtkTextMessage extends H {
    constructor() {
        super();
        this.__registerHost();
        /** Date object of now, to calculate distance between dates */
        this.now = new Date();
        /** Whether the message is continued by same user */
        this.isContinued = false;
        /** Icon pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
        /** show message in bubble */
        this.showBubble = false;
    }
    render() {
        return (h(Host, { key: '128a6e757cf71a11aef8c93749b6388cee1a65d3' }, !this.isContinued && (h(ChatHead, { key: '35fd68c340c5133b3940bc5a200aaed48f366a0e', name: this.message.displayName, time: this.message.time, now: this.now })), h("div", { key: '189244910e2511399a9dcb57647d7c63ed918712', class: {
                body: true,
                bubble: this.showBubble,
            }, part: "body" }, h("div", { key: '2b949b44c13aae1295c01aaa3915bcd45381447a', class: { text: true, emoji: hasOnlyEmojis(this.message.message) } }, h(TextMessageView, { key: '3659ef1412e9731352a3270cf2815a9fa78018fb', message: this.message.message })))));
    }
}, [0, "rtk-text-message", {
        "message": [16],
        "now": [16],
        "isContinued": [516, "is-continued"],
        "iconPack": [16],
        "t": [16],
        "showBubble": [4, "show-bubble"]
    }]);
__decorate([
    SyncWithStore()
], RtkTextMessage.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkTextMessage.prototype, "t", void 0);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["rtk-text-message"];
    components.forEach(tagName => { switch (tagName) {
        case "rtk-text-message":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, RtkTextMessage);
            }
            break;
    } });
}
defineCustomElement();

export { RtkTextMessage as R, defineCustomElement as d };
