import { p as proxyCustomElement, H, d as createEvent, h, e as Host } from './p-c3592601.js';
import { a as defaultIconPack, c as useLanguage } from './p-fc4484ae.js';
import { S as SyncWithStore } from './p-989a34c9.js';
import { d as defineCustomElement$1 } from './p-2507c6c8.js';

const rtkMuteAllConfirmationCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}:host{display:block;-webkit-user-select:none;-moz-user-select:none;user-select:none}.leave-modal{position:relative;display:flex;flex-direction:column;border-radius:var(--rtk-border-radius-md, 8px);--tw-bg-opacity:1;background-color:rgba(var(--rtk-colors-background-900, 26 26 26) / var(--tw-bg-opacity));padding:var(--rtk-space-4, 16px);color:rgb(var(--rtk-colors-text-1000, 255 255 255))}.leave-modal .header h2{margin:var(--rtk-space-0, 0px);margin-bottom:var(--rtk-space-3, 12px)}.leave-modal .content{font-size:14px}.leave-message p{margin-top:var(--rtk-space-3, 12px);margin-bottom:var(--rtk-space-3, 12px)}.leave-meeting{display:flex;flex-direction:row;justify-content:space-between;gap:var(--rtk-space-2, 8px)}.leave-meeting rtk-button{flex:1 1 0%}.end-meeting{margin-top:var(--rtk-space-2, 8px)}.message{margin-bottom:var(--rtk-space-4, 16px)}label{display:flex;align-items:center}input[type='checkbox']{margin-right:var(--rtk-space-2, 8px);accent-color:rgb(var(--rtk-colors-brand-500, 33 96 253))}";
const RtkMuteAllConfirmationStyle0 = rtkMuteAllConfirmationCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkMuteAllConfirmation = /*@__PURE__*/ proxyCustomElement(class RtkMuteAllConfirmation extends H {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.stateUpdate = createEvent(this, "rtkStateUpdate", 7);
        /** Icon pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
        this.allowUnmute = true;
        this.onClose = () => {
            this.stateUpdate.emit({ activeMuteAllConfirmation: false });
        };
        this.onMuteAll = () => {
            var _a;
            (_a = this.meeting) === null || _a === void 0 ? void 0 : _a.participants.disableAllAudio(this.allowUnmute);
            this.onClose();
        };
    }
    render() {
        return (h(Host, { key: '199f56583843ca5b4e68f6a087471983c231983b' }, h("div", { key: '86b15ff17b5a9526df77d2bc9f1d1e2d938c71c4', class: "leave-modal" }, h("div", { key: '7f19f8d34586e3f8ee4661556e5f4c744facb4e8', class: "header" }, h("h2", { key: '93adfa1d849b0aa3e483c280d1078d99ac1ef73c', class: "title" }, this.t('mute_all.header'))), h("p", { key: '7532426538ef8de6280cf0246126061bff639209', class: "message" }, this.t('mute_all.description')), h("div", { key: '14f577e917ecbf867afe2e6a4f94b86122d95496', class: "content" }, h("div", { key: '2cbe2cea5befa86328d786aa3420af04bda0097e', class: "leave-meeting" }, h("rtk-button", { key: '27b26964264a4c569ef7388357623ed97dff7bdb', variant: "secondary", title: this.t('close'), onClick: this.onClose }, this.t('cancel')), h("rtk-button", { key: 'dba570b9e72a21c0b76957cac4809f61878645d3', variant: "danger", title: this.t('mute_all'), onClick: this.onMuteAll }, this.t('mute_all')))))));
    }
    static get style() { return RtkMuteAllConfirmationStyle0; }
}, [1, "rtk-mute-all-confirmation", {
        "meeting": [16],
        "states": [16],
        "iconPack": [16],
        "t": [16],
        "allowUnmute": [32]
    }]);
__decorate([
    SyncWithStore()
], RtkMuteAllConfirmation.prototype, "meeting", void 0);
__decorate([
    SyncWithStore()
], RtkMuteAllConfirmation.prototype, "states", void 0);
__decorate([
    SyncWithStore()
], RtkMuteAllConfirmation.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkMuteAllConfirmation.prototype, "t", void 0);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["rtk-mute-all-confirmation", "rtk-button"];
    components.forEach(tagName => { switch (tagName) {
        case "rtk-mute-all-confirmation":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, RtkMuteAllConfirmation);
            }
            break;
        case "rtk-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { RtkMuteAllConfirmation as R, defineCustomElement as d };
