import { p as proxyCustomElement, H, d as createEvent, h, e as Host } from './p-c3592601.js';
import { c as useLanguage, a as defaultIconPack } from './p-fc4484ae.js';
import { S as SyncWithStore } from './p-989a34c9.js';
import { d as defineCustomElement$4 } from './p-65da3d17.js';
import { d as defineCustomElement$3 } from './p-a73161da.js';
import { d as defineCustomElement$2 } from './p-23d64784.js';

const rtkDebuggerToggleCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}:host{display:block}";
const RtkDebuggerToggleStyle0 = rtkDebuggerToggleCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkDebuggerToggle$1 = /*@__PURE__*/ proxyCustomElement(class RtkDebuggerToggle extends H {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.stateUpdate = createEvent(this, "rtkStateUpdate", 7);
        /** Variant */
        this.variant = 'button';
        /** Language */
        this.t = useLanguage();
        /** Icon pack */
        this.iconPack = defaultIconPack;
    }
    toggleDebugger() {
        var _a;
        this.stateUpdate.emit({
            activeDebugger: !((_a = this.states) === null || _a === void 0 ? void 0 : _a.activeDebugger),
            activeMoreMenu: false,
        });
    }
    render() {
        return (h(Host, { key: 'e46722c024802f6c96cebb487c9049e8834c48f8', title: this.t('Troubleshooting') }, h("rtk-controlbar-button", { key: 'ee3d60dd6993d2757f763a0ae8ba173887c9ceba', size: this.size, iconPack: this.iconPack, onClick: () => this.toggleDebugger(), icon: this.iconPack.debug, label: this.t('Troubleshooting'), variant: this.variant })));
    }
    static get style() { return RtkDebuggerToggleStyle0; }
}, [1, "rtk-debugger-toggle", {
        "variant": [513],
        "meeting": [16],
        "states": [16],
        "t": [16],
        "iconPack": [16],
        "size": [513]
    }]);
__decorate([
    SyncWithStore()
], RtkDebuggerToggle$1.prototype, "meeting", void 0);
__decorate([
    SyncWithStore()
], RtkDebuggerToggle$1.prototype, "states", void 0);
__decorate([
    SyncWithStore()
], RtkDebuggerToggle$1.prototype, "t", void 0);
__decorate([
    SyncWithStore()
], RtkDebuggerToggle$1.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkDebuggerToggle$1.prototype, "size", void 0);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["rtk-debugger-toggle", "rtk-controlbar-button", "rtk-icon", "rtk-spinner"];
    components.forEach(tagName => { switch (tagName) {
        case "rtk-debugger-toggle":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, RtkDebuggerToggle$1);
            }
            break;
        case "rtk-controlbar-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "rtk-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "rtk-spinner":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}
defineCustomElement$1();

const RtkDebuggerToggle = RtkDebuggerToggle$1;
const defineCustomElement = defineCustomElement$1;

export { RtkDebuggerToggle, defineCustomElement };
