import { p as proxyCustomElement, H, h, e as Host } from './p-c3592601.js';
import { a as defaultIconPack, c as useLanguage } from './p-fc4484ae.js';
import { S as SyncWithStore } from './p-989a34c9.js';
import { d as defineCustomElement$2 } from './p-de2175ca.js';

const rtkMeetingTitleCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}:host{-webkit-user-select:none;-moz-user-select:none;user-select:none;font-size:16px;color:rgb(var(--rtk-colors-text-1000, 255 255 255))}:host([data-hidden]){display:none}.title{text-align:center;overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1}:host([size='sm']){font-size:12px}";
const RtkMeetingTitleStyle0 = rtkMeetingTitleCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkMeetingTitle$1 = /*@__PURE__*/ proxyCustomElement(class RtkMeetingTitle extends H {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        /** Icon pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
    }
    render() {
        var _a;
        const title = (_a = this.meeting) === null || _a === void 0 ? void 0 : _a.meta.meetingTitle;
        if (title == null)
            return h(Host, { "data-hidden": true });
        return (h(Host, { role: "banner", "aria-label": title }, h("rtk-tooltip", { label: title, part: "tooltip" }, h("div", { class: "title", part: "title" }, title))));
    }
    static get style() { return RtkMeetingTitleStyle0; }
}, [1, "rtk-meeting-title", {
        "meeting": [16],
        "iconPack": [16],
        "t": [16]
    }]);
__decorate([
    SyncWithStore()
], RtkMeetingTitle$1.prototype, "meeting", void 0);
__decorate([
    SyncWithStore()
], RtkMeetingTitle$1.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkMeetingTitle$1.prototype, "t", void 0);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["rtk-meeting-title", "rtk-tooltip"];
    components.forEach(tagName => { switch (tagName) {
        case "rtk-meeting-title":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, RtkMeetingTitle$1);
            }
            break;
        case "rtk-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}
defineCustomElement$1();

const RtkMeetingTitle = RtkMeetingTitle$1;
const defineCustomElement = defineCustomElement$1;

export { RtkMeetingTitle, defineCustomElement };
