import { r as registerInstance, h, H as Host } from './index-c1fb98bb.js';
import { d as defaultConfig, a as defaultIconPack, c as useLanguage } from './ui-store-1b477153.js';
import { R as Render } from './index-d31a2e33.js';
import { S as SyncWithStore } from './index-3481d5b2.js';

const rtkHeaderCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}:host{display:flex;height:var(--rtk-space-12, 48px);align-items:center;--tw-bg-opacity:1;background-color:rgba(var(--rtk-colors-background-1000, 8 8 8) / var(--tw-bg-opacity));padding-left:var(--rtk-space-4, 16px);padding-right:var(--rtk-space-4, 16px)}@media only screen and (max-device-height: 480px) and (orientation: landscape){:host{display:none !important}}@media only screen and (max-height: 480px) and (orientation: landscape){:host{display:none !important}}";
const RtkHeaderStyle0 = rtkHeaderCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkHeader = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        /** Variant */
        this.variant = 'solid';
        /** Whether to render the default UI */
        this.disableRender = false;
        /** Config */
        this.config = defaultConfig;
        /** Icon Pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
    }
    render() {
        const defaults = {
            meeting: this.meeting,
            config: this.config,
            states: this.states,
            t: this.t,
            iconPack: this.iconPack,
            size: this.size,
        };
        return (h(Host, { key: '0b3c18e3927465e198c26f79d810dadc31ebb74b' }, !this.disableRender && h(Render, { key: '480d2f17a6d831dabb3d39abceb33fbc1aa6d78d', element: "rtk-header", defaults: defaults, onlyChildren: true }), h("slot", { key: '67f89c4a3574ba22976d3aa57268aabe4ce78d2a' })));
    }
};
__decorate([
    SyncWithStore()
], RtkHeader.prototype, "meeting", void 0);
__decorate([
    SyncWithStore()
], RtkHeader.prototype, "states", void 0);
__decorate([
    SyncWithStore()
], RtkHeader.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkHeader.prototype, "t", void 0);
__decorate([
    SyncWithStore()
], RtkHeader.prototype, "size", void 0);
RtkHeader.style = RtkHeaderStyle0;

export { RtkHeader as rtk_header };
