import { r as registerInstance, c as createEvent, h, H as Host } from './index-c1fb98bb.js';
import { c as useLanguage, a as defaultIconPack } from './ui-store-1b477153.js';
import { d as downloadFile } from './file-1d408324.js';
import { S as SyncWithStore } from './index-3481d5b2.js';
import { f as formatName, s as shorten } from './string-ed1380fb.js';

const rtkImageViewerCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}.scrollbar{scrollbar-width:thin;scrollbar-color:var(--rtk-scrollbar-color, rgb(var(--rtk-colors-background-600, 60 60 60)))\n    var(--rtk-scrollbar-background, transparent)}.scrollbar::-webkit-scrollbar{height:var(--rtk-space-1\\.5, 6px);width:var(--rtk-space-1\\.5, 6px);border-radius:9999px;background-color:var(--rtk-scrollbar-background, transparent)}.scrollbar::-webkit-scrollbar-thumb{border-radius:9999px;background-color:var(--rtk-scrollbar-color, rgb(var(--rtk-colors-background-600, 60 60 60)))}:host{width:1140px;max-width:100%;box-sizing:border-box;display:flex;flex-direction:column;padding:var(--rtk-space-6, 24px);padding-top:var(--rtk-space-5, 20px);overflow-y:auto;color:rgb(var(--rtk-colors-text-1000, 255 255 255));z-index:40;border-radius:var(--rtk-border-radius-md, 8px);--tw-bg-opacity:1;background-color:rgba(var(--rtk-colors-background-900, 26 26 26) / var(--tw-bg-opacity))}.displayName{font-weight:700}.image-ctr{margin-top:var(--rtk-space-2, 8px);box-sizing:border-box;display:flex;justify-content:center;overflow:hidden}.actions{display:flex;align-items:center;justify-content:flex-end;gap:var(--rtk-space-2, 8px)}img{box-sizing:border-box;display:block;max-height:100%;max-width:100%;-o-object-fit:contain;object-fit:contain}.header{display:flex;align-items:center;justify-content:space-between;padding-bottom:var(--rtk-space-4, 16px)}.shared-by-user{overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1}:host([size='sm']) .header{flex-direction:column}:host([size='sm']) .header .actions{margin-top:var(--rtk-space-4, 16px)}";
const RtkImageViewerStyle0 = rtkImageViewerCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkImageViewer = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.close = createEvent(this, "close", 7);
        /** Language */
        this.t = useLanguage();
        /** Icon pack */
        this.iconPack = defaultIconPack;
        this.keypressListener = (e) => {
            if (e.key === 'Escape') {
                this.close.emit();
            }
        };
        this.handleOutsideClick = () => this.close.emit();
    }
    connectedCallback() {
        document.addEventListener('keydown', this.keypressListener);
        document.addEventListener('click', this.handleOutsideClick);
    }
    disconnectedCallback() {
        document.removeEventListener('keydown', this.keypressListener);
        document.removeEventListener('click', this.handleOutsideClick);
    }
    render() {
        return (h(Host, { key: '2bb235425497f7932f5cfd73ab7faa2c15d3691d', class: "scrollbar", onClick: (e) => e.stopPropagation() }, h("div", { key: '04dd5a250967f61e20b7b8fe559ca4ea1012f949', class: "header" }, h("div", { key: '9f533863c5d32c7333c872333d7c6c14c02f5827', class: "shared-by-user" }, this.t('chat.img.shared_by'), ' ', h("span", { key: '6e24710128bef29114ba0fa4f7c06561a7293a96', class: "displayName" }, formatName(shorten(this.image.displayName)))), h("div", { key: '1d7e518f2b61c74634885518450a0364691205cb', class: "actions" }, h("rtk-button", { key: 'b9ca96cf9eef4dfe347412daeec77f6b5183e5c5', onClick: () => downloadFile(this.image.link, { fallbackName: 'image' }) }, h("rtk-icon", { key: 'ee1326105412e04d113b35a8b1815f22c0699b87', icon: this.iconPack.download, slot: "start" }), "Download"), h("rtk-button", { key: '240d7f9f00f19031402bfca7c54d65a1f3bbef6d', kind: "icon", variant: "secondary", onClick: () => this.close.emit() }, h("rtk-icon", { key: '91e47a9b52baf9f28efda7b1d98f12d90724da1f', icon: this.iconPack.dismiss })))), h("div", { key: 'e50deb0d992a18b49641ccfde023f256083d05c7', class: "image-ctr" }, h("img", { key: 'febe53b5401100dd4a7e9c46693302e4c8dd711c', src: this.image.link }))));
    }
};
__decorate([
    SyncWithStore()
], RtkImageViewer.prototype, "size", void 0);
__decorate([
    SyncWithStore()
], RtkImageViewer.prototype, "t", void 0);
__decorate([
    SyncWithStore()
], RtkImageViewer.prototype, "iconPack", void 0);
RtkImageViewer.style = RtkImageViewerStyle0;

export { RtkImageViewer as rtk_image_viewer };
