import { r as registerInstance, h, H as Host } from './index-c1fb98bb.js';
import { a as defaultIconPack, c as useLanguage } from './ui-store-1b477153.js';
import { S as SyncWithStore } from './index-3481d5b2.js';

const rtkMeetingTitleCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}:host{-webkit-user-select:none;-moz-user-select:none;user-select:none;font-size:16px;color:rgb(var(--rtk-colors-text-1000, 255 255 255))}:host([data-hidden]){display:none}.title{text-align:center;overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1}:host([size='sm']){font-size:12px}";
const RtkMeetingTitleStyle0 = rtkMeetingTitleCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkMeetingTitle = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        /** Icon pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
    }
    render() {
        var _a;
        const title = (_a = this.meeting) === null || _a === void 0 ? void 0 : _a.meta.meetingTitle;
        if (title == null)
            return h(Host, { "data-hidden": true });
        return (h(Host, { role: "banner", "aria-label": title }, h("rtk-tooltip", { label: title, part: "tooltip" }, h("div", { class: "title", part: "title" }, title))));
    }
};
__decorate([
    SyncWithStore()
], RtkMeetingTitle.prototype, "meeting", void 0);
__decorate([
    SyncWithStore()
], RtkMeetingTitle.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkMeetingTitle.prototype, "t", void 0);
RtkMeetingTitle.style = RtkMeetingTitleStyle0;

export { RtkMeetingTitle as rtk_meeting_title };
