import { r as registerInstance, c as createEvent, h, F as Fragment, H as Host } from './index-c1fb98bb.js';
import { s as shorten } from './string-ed1380fb.js';
import { d as defaultConfig, a as defaultIconPack, c as useLanguage, k as gracefulStorage } from './ui-store-1b477153.js';
import { R as Render } from './index-d31a2e33.js';
import { S as SyncWithStore } from './index-3481d5b2.js';

const rtkSetupScreenCss = ":host{line-height:initial;font-family:var(--rtk-font-family, sans-serif);font-feature-settings:normal;font-variation-settings:normal}p{margin:var(--rtk-space-0, 0px);padding:var(--rtk-space-0, 0px)}:host{box-sizing:border-box;padding:var(--rtk-space-4, 16px);height:100%;min-height:100%;width:100%;display:flex;place-items:center;justify-content:center;--rtk-controlbar-button-background-color:rgb(var(--rtk-colors-background-700, 44 44 44))}.container{width:100%;max-width:1080px;display:flex;align-items:center;justify-content:space-evenly;gap:var(--rtk-space-4, 16px)}.container-tile{display:flex;height:100%;width:100%;max-width:584px;flex-direction:column;gap:var(--rtk-space-2, 8px)}.metadata{display:flex;width:100%;max-width:var(--rtk-space-80, 320px);flex-direction:column;align-items:center;text-align:center}.meeting-title{margin-bottom:var(--rtk-space-4, 16px);text-align:center;font-size:24px;font-weight:500}.join-as{margin:var(--rtk-space-0, 0px);margin-bottom:var(--rtk-space-4, 16px);text-align:center;font-size:16px;letter-spacing:-0.025em;color:rgb(var(--rtk-colors-text-600, 255 255 255 / 0.52));overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1}.uneditable-name{margin-bottom:var(--rtk-space-6, 24px)}.uneditable-name .text,.uneditable-name .name{display:inline-block}.uneditable-name .name{font-size:16px;font-weight:500}input{margin-bottom:var(--rtk-space-6, 24px);display:block;height:var(--rtk-space-10, 40px);width:100%;max-width:var(--rtk-space-80, 320px);border-radius:var(--rtk-border-radius-sm, 4px);--tw-bg-opacity:1;background-color:rgba(var(--rtk-colors-background-1000, 8 8 8) / var(--tw-bg-opacity));padding-left:var(--rtk-space-3, 12px);padding-right:var(--rtk-space-3, 12px);color:rgb(var(--rtk-colors-text-1000, 255 255 255));box-sizing:border-box;font-size:16px;outline:2px solid transparent;outline-offset:2px;transition-property:color, background-color, border-color, text-decoration-color, fill, stroke, opacity, box-shadow, transform, filter, -webkit-backdrop-filter;transition-property:color, background-color, border-color, text-decoration-color, fill, stroke, opacity, box-shadow, transform, filter, backdrop-filter;transition-property:color, background-color, border-color, text-decoration-color, fill, stroke, opacity, box-shadow, transform, filter, backdrop-filter, -webkit-backdrop-filter;transition-timing-function:cubic-bezier(0.4, 0, 0.2, 1);transition-duration:150ms}input::-moz-placeholder{color:rgb(var(--rtk-colors-text-600, 255 255 255 / 0.52))}input::placeholder{color:rgb(var(--rtk-colors-text-600, 255 255 255 / 0.52))}input{border:var(--rtk-border-width-sm, 1px) solid rgb(var(--rtk-colors-background-600, 60 60 60))}input:focus{--tw-border-opacity:1;border-color:rgba(var(--rtk-colors-brand-500, 33 96 253) / var(--tw-border-opacity))}rtk-spinner{color:rgb(var(--rtk-colors-text-1000, 255 255 255));--icon-size:var(--rtk-space-8, 32px)}:host([size='sm']) .container,:host([size='md']) .container{height:100%;flex-direction:column;justify-content:space-evenly}:host([size='sm']) .container-tile,:host([size='md']) .container-tile{height:-moz-min-content;height:min-content;flex-direction:column;justify-content:center}rtk-participant-tile{height:auto;width:100%;max-width:584px}.media-selectors{display:flex;flex-direction:column;justify-content:space-between}.media-selectors .row{display:grid;grid-template-columns:repeat(2, minmax(0, 1fr))}.no-network-badge{margin-top:var(--rtk-space-2, 8px);display:flex;width:100%;flex-direction:row;align-items:center;justify-content:flex-start;border-radius:var(--rtk-border-radius-sm, 4px);--tw-bg-opacity:1;background-color:rgba(var(--rtk-colors-brand-500, 33 96 253) / var(--tw-bg-opacity));background-color:rgba(var(--rtk-colors-danger, 255 45 45) / 0.1);padding-top:var(--rtk-space-1, 4px);padding-bottom:var(--rtk-space-1, 4px);font-size:12px;color:rgba(var(--rtk-colors-danger, 255 45 45) / 0.75)}.no-network-badge rtk-icon{margin-left:var(--rtk-space-2, 8px);margin-right:var(--rtk-space-2, 8px)}";
const RtkSetupScreenStyle0 = rtkSetupScreenCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const RtkSetupScreen = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.stateUpdate = createEvent(this, "rtkStateUpdate", 7);
        /** Config object */
        this.config = defaultConfig;
        /** Icon pack */
        this.iconPack = defaultIconPack;
        /** Language */
        this.t = useLanguage();
        this.isJoining = false;
        this.canEditName = true;
        this.canProduceAudio = true;
        this.socketStateUpdate = ({ state }) => {
            this.connectionState = state;
            if (state === 'failed')
                this.isJoining = false;
        };
        this.join = async () => {
            var _a, _b, _c;
            if (((_a = this.displayName) === null || _a === void 0 ? void 0 : _a.trim()) !== '' && !this.isJoining) {
                this.isJoining = true;
                (_b = this.meeting) === null || _b === void 0 ? void 0 : _b.self.setName(this.displayName);
                gracefulStorage.setItem('rtk-display-name', this.displayName);
                try {
                    await ((_c = this.meeting) === null || _c === void 0 ? void 0 : _c.joinRoom());
                }
                catch (e) {
                    this.isJoining = false;
                }
            }
        };
    }
    connectedCallback() {
        this.meetingChanged(this.meeting);
    }
    disconnectedCallback() {
        this.meeting.meta.removeListener('socketConnectionUpdate', this.socketStateUpdate);
    }
    componentDidLoad() {
        var _a;
        (_a = this.inputEl) === null || _a === void 0 ? void 0 : _a.focus();
    }
    meetingChanged(meeting) {
        var _a, _b, _c;
        if (meeting) {
            this.connectionState = (_a = meeting.meta.socketState) === null || _a === void 0 ? void 0 : _a.state;
            this.canEditName = (_b = meeting.self.permissions.canEditDisplayName) !== null && _b !== void 0 ? _b : true;
            this.displayName = ((_c = meeting.self.name) === null || _c === void 0 ? void 0 : _c.trim()) || (this.canEditName ? '' : 'Participant');
            meeting.meta.addListener('socketConnectionUpdate', this.socketStateUpdate);
        }
    }
    render() {
        var _a, _b, _c, _d;
        const disabled = ((_a = this.displayName) === null || _a === void 0 ? void 0 : _a.trim()) === '' || this.connectionState !== 'connected' || this.isJoining;
        const defaults = {
            meeting: this.meeting,
            config: this.config,
            states: this.states,
            size: this.size,
            iconPack: this.iconPack,
            t: this.t,
        };
        const meetingTitle = (_b = this.meeting) === null || _b === void 0 ? void 0 : _b.meta.meetingTitle.trim();
        return (h(Host, { key: 'ea88610290c5f721a9fe638928855cc31bcb975f' }, h("div", { key: '321f2a690e22c14c627e603b4f7d590800f19911', class: "container" }, h("div", { key: 'c4501f3c49417145e34024c05e8df52174289138', class: 'container-tile' }, h(Render, { key: '66514020274bb3a6df00c94e75e14785079853c1', element: "rtk-participant-tile", defaults: defaults, props: { participant: (_c = this.meeting) === null || _c === void 0 ? void 0 : _c.self, size: 'md', isPreview: true }, childProps: { participant: (_d = this.meeting) === null || _d === void 0 ? void 0 : _d.self, size: 'md' }, deepProps: true }), h("div", { key: 'e3f6ec148cc113d3efef3955d9bb96c68c36e9a7', class: 'media-selectors' }, h("rtk-microphone-selector", Object.assign({ key: '450cc901acd253dec2c40c1d2c1ff27441fcbb6c' }, defaults, { variant: "inline" })), h("rtk-camera-selector", Object.assign({ key: 'cf38bfe66aac01a51845d619521c747727f926ac' }, defaults, { variant: "inline" })), h("rtk-speaker-selector", Object.assign({ key: '33357804c4d4ba359f7348f853cd25ef1ee0f442' }, defaults, { variant: "inline" })))), h("div", { key: 'bff07c087cb1c5f6db822b38fe9485c4e69d4ecd', class: "metadata" }, meetingTitle && meetingTitle !== '' && h("div", { key: 'e9d6882f1d79b1687883a9de7a23b9ca89142c0a', class: "meeting-title" }, meetingTitle), this.canEditName ? (h(Fragment, null, h("div", { class: "join-as" }, this.t('setup_screen.join_in_as')), h("input", { placeholder: this.t('setup_screen.your_name'), value: this.displayName, spellcheck: false, autoFocus: true, ref: (el) => {
                this.inputEl = el;
            }, onInput: (e) => {
                this.displayName = e.target.value;
            }, onKeyDown: (e) => {
                if (e.key === 'Enter') {
                    this.join();
                }
            } }))) : (h("div", { class: "uneditable-name" }, h("span", { class: "text" }, this.t('setup_screen.join_in_as'), " "), ' ', h("div", { class: "name" }, shorten(this.displayName, 20)))), h("rtk-button", { key: 'd6d629f03ccabca7823c6b78e3b4dc42c2db9ecc', size: "lg", kind: "wide", onClick: this.join, disabled: disabled }, this.isJoining ? h("rtk-spinner", { iconPack: this.iconPack }) : this.t('join')), this.connectionState !== 'connected' && (h("div", { key: '92c30fa7cdef877ff80cbc74806e6824c725d284', class: "no-network-badge" }, h("rtk-icon", { key: '615e5873958f0e7502e6fbcefdca8b34892d4d2b', size: "md", variant: "danger", icon: this.iconPack.disconnected }), this.connectionState === 'failed'
            ? this.t('network.lost_extended')
            : this.t('network.lost')))))));
    }
    static get watchers() { return {
        "meeting": ["meetingChanged"]
    }; }
};
__decorate([
    SyncWithStore()
], RtkSetupScreen.prototype, "meeting", void 0);
__decorate([
    SyncWithStore()
], RtkSetupScreen.prototype, "states", void 0);
__decorate([
    SyncWithStore()
], RtkSetupScreen.prototype, "size", void 0);
__decorate([
    SyncWithStore()
], RtkSetupScreen.prototype, "iconPack", void 0);
__decorate([
    SyncWithStore()
], RtkSetupScreen.prototype, "t", void 0);
RtkSetupScreen.style = RtkSetupScreenStyle0;

export { RtkSetupScreen as rtk_setup_screen };
