import { EventEmitter } from '../../stencil-public-runtime';
import { RtkI18n, IconPack } from '../../exports';
export interface ChannelItem {
    id: string;
    name: string;
    avatarUrl?: string;
    icon?: keyof IconPack;
    latestMessage?: string;
    latestMessageTime?: Date;
    unreadCount?: number;
}
export declare class RtkChannelSelectorView {
    /** Channels */
    channels: {
        id: string;
        name: string;
        avatarUrl?: string;
        icon?: keyof IconPack;
        latestMessage?: string;
        latestMessageTime?: Date;
        unreadCount?: number;
    }[];
    /** Selected channel id */
    selectedChannelId: string;
    /** Disables search bar (default = false) */
    disableSearch: boolean;
    /** Hides avatar (default = false) */
    hideAvatar: boolean;
    /** Icon Pack */
    iconPack: IconPack;
    /** Language */
    t: RtkI18n;
    /** Render as dropdown or list (default = list) */
    viewAs: 'dropdown' | 'list';
    /** Event emitted when selected channel changes */
    channelChange: EventEmitter<{
        id: string;
        name: string;
        avatarUrl?: string;
        icon?: keyof IconPack;
        latestMessage?: string;
        latestMessageTime?: Date;
        unreadCount?: number;
    }>;
    searchQuery: string;
    showDropdown: boolean;
    $el: HTMLRtkChannelSelectorViewElement;
    private $searchEl;
    private $listEl;
    private resizeObserver;
    connectedCallback(): void;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    private calculateListHeight;
    private getFilteredChannels;
    private getTimeLabel;
    private toggleDropdown;
    private getChannelById;
    private getTotalUnreads;
    private onChannelClickHandler;
    render(): any;
}
