import { EventEmitter } from '../../stencil-public-runtime';
import { RtkI18n, IconPack } from '../../exports';
import { Size } from '../../types/props';
import type { Message } from '@cloudflare/realtimekit';
export declare class RtkChatMessage {
    $el: HTMLRtkChatMessageElement;
    /**
     * message item
     */
    message: Message;
    /**
     * is continued
     */
    isContinued: boolean;
    /**
     * Child
     */
    child: HTMLElement;
    /**
     * is unread
     */
    isUnread: boolean;
    /** Size */
    size: Size;
    /** Icon pack */
    iconPack: IconPack;
    /** Language */
    t: RtkI18n;
    /** if sender is self */
    isSelf: boolean;
    /** can edit message */
    canEdit: boolean;
    /** can delete message */
    canDelete: boolean;
    /** can quote reply this message */
    canReply: boolean;
    /** can pin this message */
    canPin: boolean;
    /** disables controls */
    disableControls: boolean;
    /** aligns message to right */
    alignRight: boolean;
    /** sender display picture url */
    senderDisplayPicture: string;
    /** hides avatar */
    hideAvatar: boolean;
    now: Date;
    /** Event for when edit is clicked on a message */
    edit: EventEmitter<Message>;
    /** Event for when reply is clicked on a message */
    reply: EventEmitter<Message>;
    /** Event for when pin is clicked on a message */
    pin: EventEmitter<Message>;
    /** Event for when edit is clicked on a message */
    delete: EventEmitter<Message>;
    /** Whether to left align the chat bubbles */
    leftAlign: boolean;
    private renderMessage;
    private onReply;
    private onPinned;
    private onDelete;
    private onEdit;
    private isTouchDevice;
    private renderControls;
    private renderAvatar;
    render(): any;
}
