import type { FileMessage } from '@cloudflare/realtimekit';
import { IconPack } from '../../lib/icons';
import { RtkI18n } from '../../lib/lang';
/**
 * A component which renders a file message from chat.
 */
export declare class RtkFileMessage {
    /** Text message object */
    message: FileMessage;
    /** Date object of now, to calculate distance between dates */
    now: Date;
    /** Whether the message is continued by same user */
    isContinued: boolean;
    /** Icon pack */
    iconPack: IconPack;
    /** Language */
    t: RtkI18n;
    /** show message in bubble */
    showBubble: boolean;
    render(): any;
}
