import { EventEmitter } from '../../stencil-public-runtime';
import type { ImageMessage } from '@cloudflare/realtimekit';
import { IconPack } from '../../lib/icons';
import { RtkI18n } from '../../lib/lang';
import { States } from '../../types/props';
/**
 * A component which renders an image message from chat.
 */
export declare class RtkImageMessage {
    /** Text message object */
    message: ImageMessage;
    /** Date object of now, to calculate distance between dates */
    now: Date;
    /** Whether the message is continued by same user */
    isContinued: boolean;
    /** Icon pack */
    iconPack: IconPack;
    /** Language */
    t: RtkI18n;
    /** show message in bubble */
    showBubble: boolean;
    status: 'loading' | 'loaded' | 'errored';
    /** Emits updated state data */
    stateUpdate: EventEmitter<States>;
    render(): any;
}
