import type { LivestreamState } from '@cloudflare/realtimekit';
import { EventEmitter } from '../../stencil-public-runtime';
import { Size, States } from '../../exports';
import { IconPack } from '../../lib/icons';
import { RtkI18n } from '../../lib/lang';
import { Meeting } from '../../types/rtk-client';
import { ControlBarVariant } from '../rtk-controlbar-button/rtk-controlbar-button';
export declare class RtkLivestreamToggle {
    /** Variant */
    variant: ControlBarVariant;
    /** Meeting object */
    meeting: Meeting;
    /** Size */
    size: Size;
    /** Icon pack */
    iconPack: IconPack;
    /** Language */
    t: RtkI18n;
    /** Is Livestream active */
    livestreamState: LivestreamState;
    /** Emits updated state data */
    stateUpdate: EventEmitter<States>;
    /**
     * Emit API error events
     */
    apiError: EventEmitter<{
        trace: string;
        message: string;
    }>;
    connectedCallback(): void;
    disconnectedCallback(): void;
    meetingChanged(meeting: Meeting): void;
    private toggleLivestream;
    private livestreamStateListener;
    private clearListeners;
    private getLivestreamLabel;
    private getLivestreamIcon;
    private isLoading;
    render(): any;
}
