import { EventEmitter } from '../../stencil-public-runtime';
import { IconPack } from '../../exports';
export interface MessageAction {
    id: string;
    label: string;
    icon?: string;
}
export declare class RtkMessageView {
    /** List of actions to show in menu */
    actions: MessageAction[];
    /** Appearance */
    variant: 'plain' | 'bubble';
    /** Render */
    viewType: 'incoming' | 'outgoing';
    /** Avatar image url */
    avatarUrl: string;
    /** Hides avatar */
    hideAvatar: boolean;
    /** Author display label */
    authorName: string;
    /** Hides author display label */
    hideAuthorName: boolean;
    /** Hides metadata (time) */
    hideMetadata: boolean;
    /** Time when message was sent */
    time: Date;
    /** Icon pack */
    iconPack: IconPack;
    /** action event */
    onAction: EventEmitter<string>;
    private renderActions;
    render(): any;
}
