import { EventEmitter } from '../../stencil-public-runtime';
import { Meeting } from '../../types/rtk-client';
import { Size, States } from '../../types/props';
import { UIConfig } from '../../types/ui-config';
import { IconPack } from '../../lib/icons';
import { RtkI18n } from '../../lib/lang';
import { RtkSidebarTab, RtkSidebarView } from '../rtk-sidebar-ui/rtk-sidebar-ui';
export type RtkSidebarSection = 'chat' | 'polls' | 'participants' | 'plugins';
/**
 * A component which handles the sidebar and
 * you can customize which sections you want, and which section you want as the default.
 */
export declare class RtkSidebar {
    private onStageStatusUpdate;
    /** Enabled sections in sidebar */
    enabledSections: RtkSidebarTab[];
    /** Default section */
    defaultSection: RtkSidebarSection;
    /** Meeting object */
    meeting: Meeting;
    /** States object */
    states: States;
    /** Config */
    config: UIConfig;
    /** Icon pack */
    iconPack: IconPack;
    /** Language */
    t: RtkI18n;
    /** Size */
    size: Size;
    /** View type */
    view: RtkSidebarView;
    currentTab: RtkSidebarSection;
    /** Emits updated state data */
    stateUpdate: EventEmitter<States>;
    isFloating: boolean;
    enablePinning: boolean;
    connectedCallback(): void;
    disconnectedCallback(): void;
    meetingChanged(meeting: Meeting): void;
    statesChanged(s?: States): void;
    viewChanged(view: RtkSidebarView): void;
    private getTabs;
    private viewSection;
    private close;
    private updateEnabledSections;
    private toggleFloating;
    render(): any;
}
