import { EventEmitter } from '../../stencil-public-runtime';
import { Meeting } from '../../types/rtk-client';
import { RtkI18n, IconPack, Size, States, UIConfig } from '../../exports';
export declare class RtkUiProvider {
    host: HTMLRtkUiProviderElement;
    /** Meeting */
    meeting: Meeting;
    /** Icon pack */
    iconPack: IconPack;
    /** Language utility */
    t: RtkI18n;
    /** Config */
    config: UIConfig;
    /** Size */
    size: Size;
    /** Whether to show setup screen or not */
    showSetupScreen: boolean;
    /**
     * Do not render children until meeting is initialized
     * @default false
     */
    noRenderUntilMeeting: boolean;
    /** States event */
    statesUpdate: EventEmitter<States>;
    private authErrorListener;
    private resizeObserver;
    listenState(e: CustomEvent<States>): void;
    private updateStates;
    connectedCallback(): void;
    disconnectedCallback(): void;
    onMeetingChange(meeting: Meeting): void;
    onIconPackChange(newIconPack: IconPack): void;
    onTChange(newT: RtkI18n): void;
    onConfigChange(config: UIConfig): void;
    onSizeChange(newSize: Size): void;
    private handleResize;
    private loadTheme;
    private roomJoinedListener;
    private waitlistedListener;
    private roomLeftListener;
    private mediaPermissionUpdateListener;
    private socketConnectionUpdateListener;
    private handleChangingMeeting;
    render(): any;
}
